# Visualization
TKV3d
AIS

# AIS_MultipleConnectedShape Class Reference

Constructs an Interactive Object connected to a list of
Interactive Objects having a Shape. These include
AIS_Shape, and AIS_ConnectedShape.
Presentation of Hidden parts is calculated automatically.
You define the Interactive Object by gathering
together several other object presentations as in
AIS_MultipleConnectedInteractive.
.

`#include <AIS_MultipleConnectedShape.hxx>`

Inheritance diagram for AIS_MultipleConnectedShape:

[legend]

## Public Member Functions

Standard_EXPORT | AIS_MultipleConnectedShape (const TopoDS_Shape &aShape)
| Initializes the shape aShape, a multiple connected Interactive Object grouping different projector-dependent representations of an entity. .
virtual Standard_EXPORT AIS_KindOfInteractive | Type () const
| Returns the kind of Interactive Object: - None - Datum - Relation - Object By default, the interactive object has a None type. Because specific shapes entail different behavior according to their sub-shapes, you may need to create a Local Context. This will allow you to specify the additional characteristics which you need to handle these shapes. .
virtual Standard_EXPORT Standard_Integer | Signature () const

Specifies additional characteristics of Interactive
Objects. A signature is, in fact, an index with integer
values assigned different properties.
This method is frequently used in conjuction with
Type to give a particular type and signature to an
Interactive Object. By default, the Interactive Object
has a None type and a signature of 0. Among the
datums, this signature is attributed to the shape
The remaining datums have the following default signatures:
- Point signature 1
- Axis signature 2
- Trihedron signature 3
- PlaneTrihedron signature 4
- Line signature 5
- Circle signature 6
- Plane signature 7.
.

virtual Standard_EXPORT Standard_Boolean | AcceptShapeDecomposition () const
| Returns true is shape decomposition is accepted. .
void | Set (const TopoDS_Shape &ashap)
| Constructs the reference shape ashap. .
const TopoDS_Shape & | Shape () const
| Returns the shape which is constructed in Set. .
virtual Standard_EXPORT void | Compute (const Handle(PrsMgr_PresentationManager2d)&aPresentationManager, const Handle(Graphic2d_GraphicObject)&aPresentation, const Standard_Integer aMode=0)
| this method should fill the presentation according to the enumerated mode of the application and to the display parameter of the application.
Standard_EXPORT const | Handle (Standard_Type)&DynamicType() const

## Protected Member Functions

virtual Standard_EXPORT void | Compute (const Handle(Prs3d_Projector)&aProjector, const Handle(Prs3d_Presentation)&aPresentation)

Calculates the 3D view aPresentation and its
updates. The latter are managed by
aPresentationManager. Each of the views in the
viewer and every modification such as rotation, for
example, entails recalculation.
It must be redefined to implement hidden line removal
for the object. The user never calls this method
himself. This is done via the InteractiveContext object
and is dependent on the point of view from which the
object is displayed.
.

virtual Standard_EXPORT void | Compute (const Handle(Prs3d_Projector)&aProjector, const Handle(Geom_Transformation)&aTrsf, const Handle(Prs3d_Presentation)&aPresentation)
| computes the presentation according to a point of view given by <aprojector>. To be Used when the associated degenerated Presentations have been transformed by <atrsf> which is not a Pure Translation. The HLR Prs can't be deducted automatically WARNING :<atrsf> must be applied to the object to display before computation !!!
virtual Standard_EXPORT void | ComputeSelection (const Handle(SelectMgr_Selection)&aSelection, const Standard_Integer aMode)

Recovers and calculates any sensitive primitive,
aSelection, available in Shape mode, specified by
aMode. As a rule, these are sensitive faces.
This method is defined as virtual. This enables you to
implement it in the creation of a new class of AIS
Interactive Object. You need to do this and in so
doing, redefine this method, if you create a class
which enriches the list of signatures and types.
.

## Private Member Functions

Standard_EXPORT void | Compute (const Handle(Prs3d_Projector)&aProjector, const Handle(Prs3d_Presentation)&aPresentation, const TopoDS_Shape &aShape)
virtual Standard_EXPORT void | Compute (const Handle(PrsMgr_PresentationManager3d)&aPresentationManager, const Handle(Prs3d_Presentation)&aPresentation, const Standard_Integer aMode=0)
| this method is redefined virtual; when the instance is connected to another InteractiveObject,this method doesn't compute anything, but just uses the presentation of this last object, with a transformation if there's one stored.

## Private Attributes

TopoDS_Shape | myShape

## Constructor & Destructor Documentation

Standard_EXPORT AIS_MultipleConnectedShape::AIS_MultipleConnectedShape | ( | const TopoDS_Shape & | aShape | ) |

## Member Function Documentation

virtual Standard_EXPORT Standard_Boolean AIS_MultipleConnectedShape::AcceptShapeDecomposition | ( |  | ) | const`[virtual]`

| Reimplemented from AIS_InteractiveObject.

virtual Standard_EXPORT void AIS_MultipleConnectedShape::Compute | ( | const Handle(PrsMgr_PresentationManager3d)& | aPresentationManager,
|  | const Handle(Prs3d_Presentation)& | aPresentation,
|  | const Standard_Integer | aMode = `0`
| ) | `[private, virtual]`

| Reimplemented from AIS_MultipleConnectedInteractive.

Standard_EXPORT void AIS_MultipleConnectedShape::Compute | ( | const Handle(Prs3d_Projector)& | aProjector,
|  | const Handle(Prs3d_Presentation)& | aPresentation,
|  | const TopoDS_Shape & | aShape
| ) | `[private]`

virtual Standard_EXPORT void AIS_MultipleConnectedShape::Compute | ( | const Handle(Prs3d_Projector)& | aProjector,
|  | const Handle(Geom_Transformation)& | aTrsf,
|  | const Handle(Prs3d_Presentation)& | aPresentation
| ) | `[protected, virtual]`

| Reimplemented from AIS_MultipleConnectedInteractive.

virtual Standard_EXPORT void AIS_MultipleConnectedShape::Compute | ( | const Handle(Prs3d_Projector)& | aProjector,
|  | const Handle(Prs3d_Presentation)& | aPresentation
| ) | `[protected, virtual]`

| Reimplemented from AIS_MultipleConnectedInteractive.

virtual Standard_EXPORT void AIS_MultipleConnectedShape::Compute | ( | const Handle(PrsMgr_PresentationManager2d)& | aPresentationManager,
|  | const Handle(Graphic2d_GraphicObject)& | aPresentation,
|  | const Standard_Integer | aMode = `0`
| ) | `[virtual]`

| Reimplemented from AIS_MultipleConnectedInteractive.

virtual Standard_EXPORT void AIS_MultipleConnectedShape::ComputeSelection | ( | const Handle(SelectMgr_Selection)& | aSelection,
|  | const Standard_Integer | aMode
| ) | `[protected, virtual]`

| Reimplemented from AIS_MultipleConnectedInteractive.

Standard_EXPORT const AIS_MultipleConnectedShape::Handle | ( | Standard_Type |  | ) | const

| Reimplemented from AIS_MultipleConnectedInteractive.

void AIS_MultipleConnectedShape::Set | ( | const TopoDS_Shape & | ashap | ) | `[inline]`

const TopoDS_Shape & AIS_MultipleConnectedShape::Shape | ( |  | ) | const`[inline]`

virtual Standard_EXPORT Standard_Integer AIS_MultipleConnectedShape::Signature | ( |  | ) | const`[virtual]`

| Reimplemented from AIS_MultipleConnectedInteractive.

virtual Standard_EXPORT AIS_KindOfInteractive AIS_MultipleConnectedShape::Type | ( |  | ) | const`[virtual]`

| Reimplemented from AIS_MultipleConnectedInteractive.

## Field Documentation

TopoDS_Shape AIS_MultipleConnectedShape::myShape `[private]`

The documentation for this class was generated from the following files:

- AIS_MultipleConnectedShape.hxx
- AIS_MultipleConnectedShape.lxx